<?php if(!isset($portal)) die();?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <link rel="stylesheet" type="text/css" href="css/style.css">
    <title>Portal</title>
  </head>
  <body>
  
    <div id="topDiv" class="scafoldingDiv">
      <div id="headerMainDiv">
        <a href="index.php">Główna</a> |
        <a href="index.php?action=showNewsList">Lista nowości</a>
        <?php if($portal->zalogowany): ?>
          | <a href="index.php?action=showSubscriptions">Subskrypcje</a>
        <?php endif; ?>
      </div>
      <div id="headerUserInfoDiv">
        <?php if($portal->zalogowany): ?>
          <div>Jesteś zalogowany jako: <?=$portal->zalogowany->nazwa?></div>
          <div><a href="index.php?action=logout">Wylogowanie</a></div>
        <?php else: ?>
          <div>Nie jesteś zalogowany.</div>
          <div><a href="index.php?action=showLoginForm">Logowanie</a></div>
        <?php endif ?>
      </div>
    </div>
    
    <div id="centerDiv" class="scafoldingDiv">
      <div id="mainContentDiv">
        <?php
          switch($action):
            case 'showLoginForm' :
              include 'templates/loginForm.php';
              break;
            case 'showFullStats' :
              echo $portal->getFullStats();
              include 'templates/statsForm.php';
              break;
            case 'showNewsList':
              $portal->showNewsList(ROWS_ON_PAGE);
              break;
            case 'showNews' :
              $news = $portal->getNews();
              include 'templates/singleNewsTemplate.php';
              break;
            case 'showMain':
            default:
              include 'templates/innerContentDiv.php';
          endswitch;
        ?>
      </div>
      
      <div id="rightSideDiv">
        <div class="header">Nowości</div>
        <div class="content">
          <?php 
            if($newsHeaders){
              include 'templates/newsHeaders.php';
            } else {
              echo 'Brak nowości';
            }
          ?>
        </div>
      </div>
    </div>
    
    <div id="footerDiv" class="scafoldingDiv">
      <div>
        <?php if($stats = $portal->getShortStats($timeout)):?>
          W ciągu ostatnich <?=$stats['timeout']?> minut stronę odwiedziło
          <?=$stats['allUsers']?> gości, w tym <?=$stats['regUsers']?> 
          zarejestrowanych użytkowników.
        <?php else:?>
          Statystyki nie są dostępne.
        <?php endif;?>
      </div>
      <div>Zobacz pozostałe
        <a href="index.php?action=showFullStats">statystyki</a>.</div>
    </div>
    
  </body>
</html>
